/*      */ package wifi;
/*      */ 
/*      */ import android.app.Application;
/*      */ import android.content.BroadcastReceiver;
/*      */ import android.content.Context;
/*      */ import android.content.Intent;
/*      */ import android.content.IntentFilter;
/*      */ import android.net.ConnectivityManager;
/*      */ import android.net.NetworkInfo;
/*      */ import android.net.wifi.ScanResult;
/*      */ import android.net.wifi.WifiConfiguration;
/*      */ import android.net.wifi.WifiInfo;
/*      */ import android.net.wifi.WifiManager;
/*      */ import android.os.Build;
/*      */ import anywheresoftware.b4a.BA;
/*      */ import anywheresoftware.b4a.BA.Author;
/*      */ import anywheresoftware.b4a.BA.ShortName;
/*      */ import anywheresoftware.b4a.BA.Version;
/*      */ import java.net.NetworkInterface;
/*      */ import java.util.ArrayList;
/*      */ import java.util.Collections;
/*      */ import java.util.Comparator;
/*      */ import java.util.List;
/*      */ import java.util.concurrent.TimeUnit;
/*      */ 
/*      */ @ShortName("MLwifi")
/*      */ @Version(3.07F)
/*      */ @Author("V-2.17 by Jem Miller - Missing Link Software; V-3.00 by bgsoft")
/*      */ public class MLwifi {
/*      */   public static final int WIFI_2_4GHZ_BAND = 1;
/*      */   
/*      */   public static final int WIFI_5GHZ_BAND = 2;
/*      */   
/*      */   public static final int CHANNEL_WIDTH_20MHZ = 0;
/*      */   
/*      */   public static final int CHANNEL_WIDTH_40MHZ = 1;
/*      */   
/*      */   public static final int CHANNEL_WIDTH_80MHZ = 2;
/*      */   
/*      */   public static final int CHANNEL_WIDTH_160MHZ = 3;
/*      */   
/*      */   public static final int CHANNEL_WIDTH_80MHZ_PLUS_MHZ = 4;
/*      */   
/*      */   private static final double DISTANCE_MHZ_M = 27.55D;
/*      */   
/*      */   public static final int WIFI_MODE_FULL = 1;
/*      */   
/*      */   public static final int WIFI_MODE_SCAN_ONLY = 2;
/*      */   
/*      */   public static final int WIFI_MODE_FULL_HIGH_PERF = 3;
/*      */   
/*      */   @ShortName("MLScan")
/*      */   public static class MLWifiScanner {
/*      */     WifiManager WifiObj;
/*      */     
/*      */     WifiScanReceiver wifiReciever;
/*      */     
/*      */     private class WifiScanReceiver extends BroadcastReceiver {
/*      */       MLwifi.MLWifiScanner tScan;
/*      */       
/*      */       public WifiScanReceiver(MLwifi.MLWifiScanner tmpScan) {
/*  996 */         this.tScan = tmpScan;
/*      */       }
/*      */       
/*      */       public void onReceive(Context c, Intent intent) {
/* 1003 */         if (this.tScan.NoEventOnSysScan && !this.tScan.OnScan)
/*      */           return; 
/* 1005 */         String ssid = "", bssid = "", tmp = "", secur = "";
/* 1006 */         int lev = 0, freq = 0, freq0 = 0, freq1 = 0, channelwidth = 0;
/* 1007 */         this.tScan.Results = this.tScan.WifiObj.getScanResults();
/* 1010 */         Comparator<ScanResult> comparator = new Comparator<ScanResult>() {
/*      */             public int compare(ScanResult lhs, ScanResult rhs) {
/* 1013 */               return (lhs.level < rhs.level) ? 1 : ((lhs.level == rhs.level) ? 0 : -1);
/*      */             }
/*      */           };
/* 1016 */         Collections.sort(this.tScan.Results, comparator);
/* 1018 */         this.tScan.wifis = new String[this.tScan.Results.size()];
/* 1020 */         for (int i = 0; i < this.tScan.Results.size(); i++) {
/* 1021 */           ScanResult Result = this.tScan.Results.get(i);
/* 1022 */           ssid = Result.SSID;
/* 1023 */           bssid = Result.BSSID;
/* 1024 */           tmp = Result.capabilities;
/* 1025 */           lev = Result.level;
/* 1026 */           freq = Result.frequency;
/* 1027 */           if (MLwifi.APIversion() >= 23) {
/* 1028 */             freq0 = Result.centerFreq0;
/* 1029 */             freq1 = Result.centerFreq1;
/* 1030 */             channelwidth = Result.channelWidth;
/*      */           } else {
/* 1032 */             freq0 = 0;
/* 1032 */             freq1 = 0;
/* 1032 */             channelwidth = -1;
/*      */           } 
/* 1034 */           if (tmp.contains("WPA2")) {
/* 1035 */             secur = "WPA2";
/* 1036 */           } else if (tmp.contains("WPA")) {
/* 1037 */             secur = "WPA";
/* 1038 */           } else if (tmp.contains("WEP")) {
/* 1039 */             secur = "WEP";
/*      */           } else {
/* 1040 */             secur = "NONE";
/*      */           } 
/* 1041 */           this.tScan.wifis[i] = String.valueOf(ssid) + "," + secur + "," + lev + "," + (MLwifi.isSavedWifiAP2(ssid) ? "Saved" : "") + "," + 
/* 1042 */             bssid + "," + MLwifi.CalcWifiPct(lev) + "," + freq + "," + freq0 + "," + freq1 + "," + channelwidth + "," + MLwifi
/* 1043 */             .ieee80211_frequency_to_channel(freq) + "," + MLwifi.WifiBand_24G_5G(freq) + "," + 
/* 1044 */             String.format("%.2f", new Object[] { Double.valueOf(MLwifi.access$3(freq, lev)) }).replace(",", ".");
/*      */         } 
/* 1048 */         if (MLwifi.MLWifiScanner.this._ba.subExists(String.valueOf(this.tScan.eventname) + "_scandone"))
/* 1049 */           MLwifi.MLWifiScanner.this._ba.raiseEventFromDifferentThread(this.tScan, null, 0, String.valueOf(this.tScan.eventname) + "_scandone", 
/* 1050 */               false, new Object[] { this.tScan.wifis, Integer.valueOf(this.tScan.wifis.length) }); 
/* 1052 */         this.tScan.OnScan = false;
/*      */       }
/*      */     }
/*      */     
/*      */     private String eventname = "";
/*      */     
/*      */     protected List<ScanResult> Results = null;
/*      */     
/*      */     BA _ba = null;
/*      */     
/*      */     private boolean NoEventOnSysScan;
/*      */     
/*      */     private boolean OnScan = false;
/*      */     
/*      */     public String[] wifis;
/*      */     
/*      */     public void startScan(BA ba, String EventName, boolean NoEventOnSystemScan) {
/*      */       Application application = BA.applicationContext;
/*      */       if (this._ba == null) {
/*      */         this._ba = ba;
/*      */         this.WifiObj = (WifiManager)application.getSystemService("wifi");
/*      */         this.eventname = EventName.toLowerCase();
/*      */         this.NoEventOnSysScan = NoEventOnSystemScan;
/*      */         this.wifiReciever = new WifiScanReceiver(this);
/*      */       } 
/*      */       updateWifiList(ba);
/*      */     }
/*      */     
/*      */     public void updateWifiList(BA ba) {
/*      */       Application application = BA.applicationContext;
/*      */       if (this.WifiObj != null && this.WifiObj.isWifiEnabled()) {
/*      */         if (this.wifiReciever == null)
/*      */           this.wifiReciever = new WifiScanReceiver(this); 
/*      */         application.registerReceiver(this.wifiReciever, new IntentFilter("android.net.wifi.SCAN_RESULTS"));
/*      */         this.OnScan = true;
/*      */         this.WifiObj.startScan();
/*      */       } 
/*      */     }
/*      */     
/*      */     public void stopScan(BA ba) {
/*      */       Application application = BA.applicationContext;
/*      */       application.unregisterReceiver(this.wifiReciever);
/*      */     }
/*      */     
/*      */     public String getBSSID(int EntryNumber) {
/* 1065 */       return ((ScanResult)this.Results.get(EntryNumber)).BSSID;
/*      */     }
/*      */     
/*      */     public String WifiCap(int EntryNumber) {
/* 1079 */       String line = "";
/* 1080 */       line = String.valueOf(((ScanResult)this.Results.get(EntryNumber)).SSID) + "," + ((ScanResult)this.Results.get(EntryNumber)).BSSID + "," + ((ScanResult)this.Results.get(EntryNumber)).capabilities;
/* 1081 */       return line;
/*      */     }
/*      */     
/*      */     public boolean isSavedWifiAP(int EntryNumber) {
/*      */       try {
/* 1095 */         return MLwifi.isSavedWifiAP2(((ScanResult)this.Results.get(EntryNumber)).SSID);
/*      */       } catch (Exception e) {
/* 1096 */         return false;
/*      */       } 
/*      */     }
/*      */     
/*      */     public boolean connectWifiAP(int EntryNumber) {
/*      */       try {
/* 1109 */         String ssid = ((ScanResult)this.Results.get(EntryNumber)).SSID;
/* 1110 */         String bssid = ((ScanResult)this.Results.get(EntryNumber)).BSSID;
/* 1111 */         return MLwifi.connectWifiAP2(ssid, bssid);
/*      */       } catch (Exception e) {
/* 1112 */         return false;
/*      */       } 
/*      */     }
/*      */     
/*      */     public List<String> listSavedNetworks() {
/* 1121 */       Application application = BA.applicationContext;
/* 1122 */       List<String> netlst = new ArrayList<String>();
/* 1124 */       WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/* 1126 */       for (WifiConfiguration tmp : wifiManager.getConfiguredNetworks())
/* 1127 */         netlst.add(String.valueOf(tmp.SSID) + "," + tmp.BSSID + "," + String.valueOf(tmp.networkId)); 
/* 1129 */       return netlst;
/*      */     }
/*      */     
/*      */     public boolean saveWifiAP(int EntryNumber, String securityType, String Password) {
/*      */       int security;
/* 1143 */       String ssid = ((ScanResult)this.Results.get(EntryNumber)).SSID;
/* 1144 */       String bssid = ((ScanResult)this.Results.get(EntryNumber)).BSSID;
/* 1147 */       if (securityType.equals("NONE")) {
/* 1148 */         security = 0;
/* 1149 */       } else if (securityType.equals("WEP")) {
/* 1150 */         security = 1;
/* 1151 */       } else if (securityType.contains("WPA")) {
/* 1152 */         security = 2;
/*      */       } else {
/* 1154 */         return false;
/*      */       } 
/* 1156 */       return MLwifi.saveWifiAP2(ssid, bssid, security, Password, true);
/*      */     }
/*      */     
/*      */     public boolean removeWifiAP(int NetId) {
/* 1167 */       Application application = BA.applicationContext;
/* 1169 */       WifiManager wm = (WifiManager)application.getSystemService("wifi");
/* 1170 */       if (wm == null || !wm.isWifiEnabled())
/* 1170 */         return false; 
/* 1172 */       boolean ok = wm.removeNetwork(NetId);
/* 1173 */       wm.saveConfiguration();
/* 1175 */       return ok;
/*      */     }
/*      */   }
/*      */   
/*      */   public void EnableWifi(boolean Enabled) {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager wifi = (WifiManager)application.getSystemService("wifi");
/*      */       wifi.setWifiEnabled(Enabled);
/*      */     } catch (Exception exception) {}
/*      */   }
/*      */   
/*      */   public boolean isWifiEnabled() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager wifi = (WifiManager)application.getSystemService("wifi");
/*      */       return wifi.isWifiEnabled();
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public static int APIversion() {
/*      */     int currentapiVersion = Build.VERSION.SDK_INT;
/*      */     return currentapiVersion;
/*      */   }
/*      */   
/*      */   public static String WifiMACAddress() {
/*      */     if (APIversion() >= 23) {
/*      */       try {
/*      */         String interfaceName = "wlan0";
/*      */         List<NetworkInterface> interfaces = Collections.list(NetworkInterface.getNetworkInterfaces());
/*      */         for (NetworkInterface intf : interfaces) {
/*      */           if (!intf.getName().equalsIgnoreCase(interfaceName))
/*      */             continue; 
/*      */           byte[] mac = intf.getHardwareAddress();
/*      */           if (mac == null)
/*      */             return ""; 
/*      */           StringBuilder buf = new StringBuilder();
/*      */           byte b;
/*      */           int i;
/*      */           byte[] arrayOfByte1;
/*      */           for (i = (arrayOfByte1 = mac).length, b = 0; b < i; ) {
/*      */             byte aMac = arrayOfByte1[b];
/*      */             buf.append(String.format("%02X:", new Object[] { Byte.valueOf(aMac) }));
/*      */             b++;
/*      */           } 
/*      */           if (buf.length() > 0)
/*      */             buf.deleteCharAt(buf.length() - 1); 
/*      */           return buf.toString();
/*      */         } 
/*      */       } catch (Exception ex) {
/*      */         return "";
/*      */       } 
/*      */       return "";
/*      */     } 
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager manager = (WifiManager)application.getSystemService("wifi");
/*      */       WifiInfo info = manager.getConnectionInfo();
/*      */       return info.getMacAddress();
/*      */     } catch (Exception ex) {
/*      */       return "";
/*      */     } 
/*      */   }
/*      */   
/*      */   public static String WifiIpAddress() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/*      */       WifiInfo wifiInfo = wifiManager.getConnectionInfo();
/*      */       int ipAddress = wifiInfo.getIpAddress();
/*      */       String ip = null;
/*      */       ip = String.format("%d.%d.%d.%d", new Object[] { Integer.valueOf(ipAddress & 0xFF), Integer.valueOf(ipAddress >> 8 & 0xFF), Integer.valueOf(ipAddress >> 16 & 0xFF), Integer.valueOf(ipAddress >> 24 & 0xFF) });
/*      */       return ip;
/*      */     } catch (Exception ex) {
/*      */       return "";
/*      */     } 
/*      */   }
/*      */   
/*      */   public static String WifiSSID() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       String st = "";
/*      */       WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/*      */       WifiInfo wifiInfo = wifiManager.getConnectionInfo();
/*      */       st = wifiInfo.getSSID().replace('"', ' ');
/*      */       return st.trim();
/*      */     } catch (Exception ex) {
/*      */       return "";
/*      */     } 
/*      */   }
/*      */   
/*      */   public int WifiSignal() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/*      */       int rssi = wifiManager.getConnectionInfo().getRssi();
/*      */       return rssi;
/*      */     } catch (Exception e) {
/*      */       return 0;
/*      */     } 
/*      */   }
/*      */   
/*      */   public int WifiStrength() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/*      */       int rssi = wifiManager.getConnectionInfo().getRssi();
/*      */       int level = WifiManager.calculateSignalLevel(rssi, 101);
/*      */       return level;
/*      */     } catch (Exception e) {
/*      */       return 0;
/*      */     } 
/*      */   }
/*      */   
/*      */   public static int CalcWifiPct(int WifiSignal) {
/*      */     double MIN_RSSI = -100.0D, MAX_RSSI = -50.0D, ws = WifiSignal;
/*      */     if (ws <= MIN_RSSI)
/*      */       return 0; 
/*      */     if (ws >= MAX_RSSI)
/*      */       return 100; 
/*      */     return (int)(100.0D * (ws - MIN_RSSI) / (MAX_RSSI - MIN_RSSI));
/*      */   }
/*      */   
/*      */   public int WifiSignalPct() {
/*      */     return CalcWifiPct(WifiSignal());
/*      */   }
/*      */   
/*      */   public int WifiLinkSpeed() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/*      */       WifiInfo wi = wifiManager.getConnectionInfo();
/*      */       return wi.getLinkSpeed();
/*      */     } catch (Exception e) {
/*      */       return 0;
/*      */     } 
/*      */   }
/*      */   
/*      */   public int WifiFrequency() {
/*      */     if (APIversion() >= 21) {
/*      */       Application application = BA.applicationContext;
/*      */       try {
/*      */         WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/*      */         WifiInfo wi = wifiManager.getConnectionInfo();
/*      */         return wi.getFrequency();
/*      */       } catch (Exception e) {
/*      */         return 0;
/*      */       } 
/*      */     } 
/*      */     return 0;
/*      */   }
/*      */   
/*      */   public int WifiChannel() {
/*      */     return ieee80211_frequency_to_channel(WifiFrequency());
/*      */   }
/*      */   
/*      */   private static int ieee80211_frequency_to_channel(int freq) {
/*      */     if (freq == 2484)
/*      */       return 14; 
/*      */     if (freq >= 2412 && freq < 2484)
/*      */       return (freq - 2407) / 5; 
/*      */     if (freq >= 5000 && freq <= 6000)
/*      */       return freq / 5 - 1000; 
/*      */     return -1;
/*      */   }
/*      */   
/*      */   public int WifiBand() {
/*      */     int freq = WifiFrequency();
/*      */     return WifiBand_24G_5G(freq);
/*      */   }
/*      */   
/*      */   private static int WifiBand_24G_5G(int freq) {
/*      */     if (freq >= 5000)
/*      */       return 2; 
/*      */     if (freq >= 2412 && freq <= 2484)
/*      */       return 1; 
/*      */     return 0;
/*      */   }
/*      */   
/*      */   public boolean is5GHzBandSupported() {
/*      */     if (APIversion() >= 21)
/*      */       try {
/*      */         Application application = BA.applicationContext;
/*      */         WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/*      */         return wifiManager.is5GHzBandSupported();
/*      */       } catch (Exception e) {
/*      */         return false;
/*      */       }  
/*      */     return false;
/*      */   }
/*      */   
/*      */   public double WifiAPDistance() {
/*      */     if (APIversion() >= 21) {
/*      */       Application application = BA.applicationContext;
/*      */       try {
/*      */         WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/*      */         WifiInfo wi = wifiManager.getConnectionInfo();
/*      */         return calculateAPDistance(wi.getFrequency(), wi.getRssi());
/*      */       } catch (Exception e) {
/*      */         return 0.0D;
/*      */       } 
/*      */     } 
/*      */     return 0.0D;
/*      */   }
/*      */   
/*      */   private static double calculateAPDistance(int frequency, int level) {
/*      */     return Math.pow(10.0D, (27.55D - 20.0D * Math.log10(frequency) + Math.abs(level)) / 20.0D);
/*      */   }
/*      */   
/*      */   private static WifiManager.WifiLock wifiLock = null;
/*      */   
/*      */   public static boolean holdWifiOn() {
/*      */     return WifiLockOnOff(true, 1);
/*      */   }
/*      */   
/*      */   public static boolean holdWifiOn2(int lockType) {
/*      */     return WifiLockOnOff(true, lockType);
/*      */   }
/*      */   
/*      */   public static boolean releaseWifiOn() {
/*      */     return WifiLockOnOff(false, 1);
/*      */   }
/*      */   
/*      */   private static boolean WifiLockOnOff(boolean OnOff, int lockType) {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       if (wifiLock == null) {
/*      */         WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/*      */         if (wifiManager != null) {
/*      */           wifiLock = wifiManager.createWifiLock(lockType, "MLwifi");
/*      */           wifiLock.setReferenceCounted(false);
/*      */         } 
/*      */       } 
/*      */       if (wifiLock != null) {
/*      */         if (OnOff) {
/*      */           wifiLock.acquire();
/*      */         } else if (wifiLock.isHeld()) {
/*      */           wifiLock.release();
/*      */         } 
/*      */         return true;
/*      */       } 
/*      */       return false;
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public static boolean isWifiHeldOn() {
/*      */     try {
/*      */       if (wifiLock != null)
/*      */         return wifiLock.isHeld(); 
/*      */       return false;
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public boolean isWifiConnectedOld() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       ConnectivityManager connManager = (ConnectivityManager)application.getSystemService("connectivity");
/*      */       NetworkInfo mWifi = connManager.getNetworkInfo(1);
/*      */       return mWifi.isConnected();
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public boolean isWifiConnected() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       ConnectivityManager connectivityManager = (ConnectivityManager)application.getSystemService("connectivity");
/*      */       NetworkInfo activeNetworkInfo = connectivityManager.getActiveNetworkInfo();
/*      */       return (activeNetworkInfo != null && activeNetworkInfo.getType() == 1 && activeNetworkInfo.isConnected() && activeNetworkInfo.isAvailable());
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public boolean isMobileConnected() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       ConnectivityManager connectivityManager = (ConnectivityManager)application.getSystemService("connectivity");
/*      */       NetworkInfo activeNetworkInfo = connectivityManager.getActiveNetworkInfo();
/*      */       return (activeNetworkInfo != null && activeNetworkInfo.getType() == 0 && activeNetworkInfo.isConnected() && activeNetworkInfo.isAvailable());
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public int ActiveNetworkType() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       ConnectivityManager connectivityManager = (ConnectivityManager)application.getSystemService("connectivity");
/*      */       NetworkInfo activeNetworkInfo = connectivityManager.getActiveNetworkInfo();
/*      */       if (activeNetworkInfo != null && activeNetworkInfo.isConnected() && activeNetworkInfo.isAvailable())
/*      */         return activeNetworkInfo.getType(); 
/*      */       return -1;
/*      */     } catch (Exception e) {
/*      */       return -1;
/*      */     } 
/*      */   }
/*      */   
/*      */   public String ActiveNetworkTypeName() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       ConnectivityManager connectivityManager = (ConnectivityManager)application.getSystemService("connectivity");
/*      */       NetworkInfo activeNetworkInfo = connectivityManager.getActiveNetworkInfo();
/*      */       if (activeNetworkInfo != null && activeNetworkInfo.isConnected() && activeNetworkInfo.isAvailable())
/*      */         return activeNetworkInfo.getTypeName(); 
/*      */       return "";
/*      */     } catch (Exception e) {
/*      */       return "";
/*      */     } 
/*      */   }
/*      */   
/*      */   public boolean isOnline() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       ConnectivityManager connectivityManager = (ConnectivityManager)application.getSystemService("connectivity");
/*      */       NetworkInfo activeNetworkInfo = connectivityManager.getActiveNetworkInfo();
/*      */       return (activeNetworkInfo != null && activeNetworkInfo.isConnected() && activeNetworkInfo.isAvailable());
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public boolean isOnlinePing() {
/*      */     return isOnlinePing2("8.8.8.8");
/*      */   }
/*      */   
/*      */   public boolean isOnlinePing2(String IpHost) {
/*      */     if (!isOnline())
/*      */       return false; 
/*      */     Runtime runtime = Runtime.getRuntime();
/*      */     try {
/*      */       Process ipProcess = runtime.exec("/system/bin/ping -c 1 " + IpHost.trim());
/*      */       int exitValue = ipProcess.waitFor();
/*      */       return (exitValue == 0);
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public boolean isOnlinePing3(long timeout) {
/*      */     return isOnlinePing4("8.8.8.8", timeout);
/*      */   }
/*      */   
/*      */   public boolean isOnlinePing4(String IpHost, long timeout) {
/*      */     if (!isOnline())
/*      */       return false; 
/*      */     Runtime runtime = Runtime.getRuntime();
/*      */     try {
/*      */       Process ipProcess = runtime.exec("/system/bin/ping -c 1 " + IpHost.trim());
/*      */       if (!waitFor2(timeout, TimeUnit.MILLISECONDS, ipProcess))
/*      */         return false; 
/*      */       int exitValue = ipProcess.exitValue();
/*      */       return (exitValue == 0);
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   private boolean waitFor2(long timeout, TimeUnit unit, Process process) throws InterruptedException {
/*      */     long startTime = System.currentTimeMillis();
/*      */     while (true) {
/*      */       try {
/*      */         process.exitValue();
/*      */         return true;
/*      */       } catch (IllegalThreadStateException ex) {
/*      */         Thread.sleep(10L);
/*      */         if (System.currentTimeMillis() - startTime >= timeout)
/*      */           break; 
/*      */       } 
/*      */     } 
/*      */     return false;
/*      */   }
/*      */   
/*      */   public boolean isOnlinePing5(BA ba, long timeout) {
/*      */     return isOnlinePing6(ba, "8.8.8.8", timeout);
/*      */   }
/*      */   
/*      */   public boolean isOnlinePing6(BA ba, String IpHost, final long timeout) {
/*      */     if (!isOnline())
/*      */       return false; 
/*      */     Runtime runtime = Runtime.getRuntime();
/*      */     try {
/*      */       final Process ipProcess = runtime.exec("/system/bin/ping -c 1 " + IpHost.trim());
/*      */       final BA _ba = ba;
/*      */       (new Thread(new Runnable() {
/*      */             public void run() {
/*      */               int exitValue;
/*      */               try {
/*      */                 if (timeout <= 0L) {
/*      */                   exitValue = ipProcess.waitFor();
/*      */                 } else if (MLwifi.this.waitFor2(timeout, TimeUnit.MILLISECONDS, ipProcess)) {
/*      */                   exitValue = ipProcess.exitValue();
/*      */                 } else {
/*      */                   exitValue = -1;
/*      */                 } 
/*      */               } catch (InterruptedException e) {
/*      */                 exitValue = -1;
/*      */               } 
/*      */               String baEventName = "isonline_pingdone";
/*      */               if (_ba.subExists(baEventName))
/*      */                 _ba.raiseEventFromDifferentThread(this, null, 0, baEventName, false, new Object[] { Boolean.valueOf((exitValue == 0)) }); 
/*      */             }
/*      */           })).start();
/*      */       return true;
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public static boolean saveWifiAP(String ssid, int security, String password, boolean connect) {
/*      */     return saveWifiAP2(ssid, "", security, password, connect);
/*      */   }
/*      */   
/*      */   private static boolean saveWifiAP2(String ssid, String bssid, int security, String password, boolean connect) {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiConfiguration wc = new WifiConfiguration();
/*      */       if (ssid.startsWith("\"")) {
/*      */         wc.SSID = ssid;
/*      */       } else {
/*      */         wc.SSID = "\"".concat(ssid).concat("\"");
/*      */       } 
/*      */       if (bssid.trim().length() > 0)
/*      */         wc.BSSID = bssid; 
/*      */       wc.hiddenSSID = false;
/*      */       wc.priority = 40;
/*      */       wc.status = 1;
/*      */       wc.allowedProtocols.set(1);
/*      */       wc.allowedProtocols.set(0);
/*      */       wc.allowedPairwiseCiphers.set(2);
/*      */       wc.allowedPairwiseCiphers.set(1);
/*      */       wc.allowedGroupCiphers.set(0);
/*      */       wc.allowedGroupCiphers.set(1);
/*      */       wc.allowedGroupCiphers.set(3);
/*      */       wc.allowedGroupCiphers.set(2);
/*      */       if (security == 2) {
/*      */         wc.allowedKeyManagement.set(1);
/*      */         wc.preSharedKey = "\"".concat(password).concat("\"");
/*      */       } else if (security == 1) {
/*      */         wc.allowedKeyManagement.set(0);
/*      */         wc.allowedAuthAlgorithms.set(0);
/*      */         wc.allowedAuthAlgorithms.set(1);
/*      */         if (isHex(password)) {
/*      */           wc.wepKeys[0] = password;
/*      */         } else {
/*      */           wc.wepKeys[0] = "\"".concat(password).concat("\"");
/*      */         } 
/*      */         wc.wepTxKeyIndex = 0;
/*      */       } else {
/*      */         wc.allowedKeyManagement.set(0);
/*      */         wc.allowedAuthAlgorithms.clear();
/*      */       } 
/*      */       WifiManager wm = (WifiManager)application.getSystemService("wifi");
/*      */       if (wm == null)
/*      */         return false; 
/*      */       int NetId = wm.addNetwork(wc);
/*      */       if (NetId <= 0)
/*      */         return false; 
/*      */       boolean St = true;
/*      */       if (connect)
/*      */         St = wm.enableNetwork(NetId, true); 
/*      */       wm.saveConfiguration();
/*      */       return St;
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   private static boolean isHex(String in) {
/*      */     try {
/*      */       int t = Integer.parseInt(in, 16);
/*      */       return true;
/*      */     } catch (NumberFormatException e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public static boolean isSavedWifiAP(String ssid) {
/*      */     return isSavedWifiAP2(ssid);
/*      */   }
/*      */   
/*      */   private static boolean isSavedWifiAP2(String ssid) {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager wm = (WifiManager)application.getSystemService("wifi");
/*      */       if (wm == null)
/*      */         return false; 
/*      */       List<WifiConfiguration> tmp = wm.getConfiguredNetworks();
/*      */       if (tmp == null)
/*      */         return false; 
/*      */       if (!ssid.startsWith("\""))
/*      */         ssid = "\"".concat(ssid).concat("\""); 
/*      */       for (int i = 0; i < tmp.size(); i++) {
/*      */         if (((WifiConfiguration)tmp.get(i)).SSID.equals(ssid))
/*      */           return true; 
/*      */       } 
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */     return false;
/*      */   }
/*      */   
/*      */   public static boolean removeWifiAP(String ssid) {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager wm = (WifiManager)application.getSystemService("wifi");
/*      */       if (wm == null || !wm.isWifiEnabled())
/*      */         return false; 
/*      */       List<WifiConfiguration> tmp = wm.getConfiguredNetworks();
/*      */       if (tmp == null)
/*      */         return false; 
/*      */       if (!ssid.startsWith("\""))
/*      */         ssid = "\"".concat(ssid).concat("\""); 
/*      */       for (int i = 0; i < tmp.size(); i++) {
/*      */         if (((WifiConfiguration)tmp.get(i)).SSID.equals(ssid)) {
/*      */           int NetId = ((WifiConfiguration)tmp.get(i)).networkId;
/*      */           if (NetId <= 0)
/*      */             return false; 
/*      */           if (!wm.removeNetwork(NetId))
/*      */             return false; 
/*      */           wm.saveConfiguration();
/*      */           return true;
/*      */         } 
/*      */       } 
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */     return false;
/*      */   }
/*      */   
/*      */   public boolean disconnectWifiAP() {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager wifiManager = (WifiManager)application.getSystemService("wifi");
/*      */       return wifiManager.disconnect();
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */   }
/*      */   
/*      */   public boolean connectWifiAP(String ssid) {
/*      */     return connectWifiAP2(ssid, "");
/*      */   }
/*      */   
/*      */   private static boolean connectWifiAP2(String ssid, String bssid) {
/*      */     Application application = BA.applicationContext;
/*      */     try {
/*      */       WifiManager wm = (WifiManager)application.getSystemService("wifi");
/*      */       if (wm == null || !wm.isWifiEnabled())
/*      */         return false; 
/*      */       List<WifiConfiguration> tmp = wm.getConfiguredNetworks();
/*      */       if (tmp == null)
/*      */         return false; 
/*      */       if (!ssid.startsWith("\""))
/*      */         ssid = "\"".concat(ssid).concat("\""); 
/*      */       for (int i = 0; i < tmp.size(); i++) {
/*      */         if ((ssid.trim().length() > 0 && ((WifiConfiguration)tmp.get(i)).SSID != null && ((WifiConfiguration)tmp.get(i)).SSID.equals(ssid)) || (bssid.trim().length() > 0 && ((WifiConfiguration)tmp.get(i)).BSSID != null && ((WifiConfiguration)tmp.get(i)).BSSID.equals(bssid))) {
/*      */           int NetId = ((WifiConfiguration)tmp.get(i)).networkId;
/*      */           if (NetId <= 0)
/*      */             return false; 
/*      */           boolean St = wm.enableNetwork(NetId, true);
/*      */           return St;
/*      */         } 
/*      */       } 
/*      */     } catch (Exception e) {
/*      */       return false;
/*      */     } 
/*      */     return false;
/*      */   }
/*      */ }


/* Location:              C:\Users\Andy\Downloads\MLwifi_3.07\MLwifi.jar!\wifi\MLwifi.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       1.1.3
 */